diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 2de0ebacec..ff9a9fc911 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -8557,7 +8557,7 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 	/* Add object to delete */
 	object.classId = RelationRelationId;
 	object.objectId = RelationGetRelid(rel);
-	object.objectSubId = attnum;
+	object.objectSubId = attphysnum;
 	add_exact_object_address(&object, addrs);
 
 	if (!recursing)
@@ -9490,11 +9490,11 @@ validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
  * parentConstr is the OID of a parent constraint; InvalidOid if this is a
  * top-level constraint.
  * numfks is the number of columns in the foreign key
- * pkattnum is the attnum array of referenced attributes.
- * fkattnum is the attnum array of referencing attributes.
+ * pkattnum is the attphysnum array of referenced attributes.
+ * fkattnum is the attphysnum array of referencing attributes.
  * numfkdelsetcols is the number of columns in the ON DELETE SET NULL/DELETE
  *      (...) clause
- * fkdelsetcols is the attnum array of the columns in the ON DELETE SET
+ * fkdelsetcols is the attphysnum array of the columns in the ON DELETE SET
  *      NULL/DELETE clause
  * pf/pp/ffeqoperators are OID array of operators between columns.
  * old_check_ok signals that this constraint replaces an existing one that
@@ -9708,12 +9708,12 @@ addFkRecurseReferenced(List **wqueue, Constraint *fkconstraint, Relation rel,
  * indexOid is the OID of the index (on pkrel) implementing this constraint.
  * parentConstr is the OID of the parent constraint (there is always one).
  * numfks is the number of columns in the foreign key
- * pkattnum is the attnum array of referenced attributes.
- * fkattnum is the attnum array of referencing attributes.
+ * pkattnum is the attphysnum array of referenced attributes.
+ * fkattnum is the attphysnum array of referencing attributes.
  * pf/pp/ffeqoperators are OID array of operators between columns.
  * numfkdelsetcols is the number of columns in the ON DELETE SET NULL/DELETE
  *      (...) clause
- * fkdelsetcols is the attnum array of the columns in the ON DELETE SET
+ * fkdelsetcols is the attphysnum array of the columns in the ON DELETE SET
  *      NULL/DELETE clause
  * old_check_ok signals that this constraint replaces an existing one that
  *		was already validated (thus this one doesn't need validation).
@@ -11144,16 +11144,16 @@ ATExecValidateConstraint(List **wqueue, Relation rel, char *constrName,
 /*
  * transformColumnNameList - transform list of column names
  *
- * Lookup each name and return its attnum and, optionally, type OID
+ * Lookup each name and return its attphysnum and, optionally, type OID
  */
 static int
 transformColumnNameList(Oid relId, List *colList,
 						int16 *attnums, Oid *atttypids)
 {
 	ListCell   *l;
-	int			attnum;
+	int			attphysnum;
 
-	attnum = 0;
+	attphysnum = 0;
 	foreach(l, colList)
 	{
 		char	   *attname = strVal(lfirst(l));
@@ -11165,19 +11165,19 @@ transformColumnNameList(Oid relId, List *colList,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("column \"%s\" referenced in foreign key constraint does not exist",
 							attname)));
-		if (attnum >= INDEX_MAX_KEYS)
+		if (attphysnum >= INDEX_MAX_KEYS)
 			ereport(ERROR,
 					(errcode(ERRCODE_TOO_MANY_COLUMNS),
 					 errmsg("cannot have more than %d keys in a foreign key",
 							INDEX_MAX_KEYS)));
-		attnums[attnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->attnum;
+		attnums[attphysnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->attphysnum;
 		if (atttypids != NULL)
-			atttypids[attnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->atttypid;
+			atttypids[attphysnum] = ((Form_pg_attribute) GETSTRUCT(atttuple))->atttypid;
 		ReleaseSysCache(atttuple);
-		attnum++;
+		attphysnum++;
 	}
 
-	return attnum;
+	return attphysnum;
 }
 
 /*
@@ -11360,7 +11360,7 @@ transformFkeyCheckAttrs(Relation pkrel,
 			indclass = (oidvector *) DatumGetPointer(indclassDatum);
 
 			/*
-			 * The given attnum list may match the index columns in any order.
+			 * The given attphysnum list may match the index columns in any order.
 			 * Check for a match, and extract the appropriate opclasses while
 			 * we're at it.
 			 *
@@ -12070,7 +12070,7 @@ ATPrepAlterColumnType(List **wqueue,
 	Node	   *transform = def->cooked_default;
 	HeapTuple	tuple;
 	Form_pg_attribute attTup;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	Oid			targettype;
 	int32		targettypmod;
 	Oid			targetcollid;
@@ -12092,10 +12092,10 @@ ATPrepAlterColumnType(List **wqueue,
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 	attTup = (Form_pg_attribute) GETSTRUCT(tuple);
-	attnum = attTup->attnum;
+	attphysnum = attTup->attphysnum;
 
 	/* Can't alter a system attribute */
-	if (attnum <= 0)
+	if (attphysnum <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("cannot alter system column \"%s\"",
@@ -12114,7 +12114,7 @@ ATPrepAlterColumnType(List **wqueue,
 
 	/* Don't alter columns used in the partition key */
 	if (has_partition_attrs(rel,
-							bms_make_singleton(attnum - FirstLowInvalidHeapAttributeNumber),
+							bms_make_singleton(attphysnum - FirstLowInvalidHeapAttributeNumber),
 							&is_expr))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
@@ -12150,7 +12150,7 @@ ATPrepAlterColumnType(List **wqueue,
 		 */
 		if (!transform)
 		{
-			transform = (Node *) makeVar(1, attnum,
+			transform = (Node *) makeVar(1, attphysnum,
 										 attTup->atttypid, attTup->atttypmod,
 										 attTup->attcollation,
 										 0);
@@ -12195,12 +12195,12 @@ ATPrepAlterColumnType(List **wqueue,
 		 * contents.
 		 */
 		newval = (NewColumnValue *) palloc0(sizeof(NewColumnValue));
-		newval->attnum = attnum;
+		newval->attphysnum = attphysnum;
 		newval->expr = (Expr *) transform;
 		newval->is_generated = false;
 
 		tab->newvals = lappend(tab->newvals, newval);
-		if (ATColumnChangeRequiresRewrite(transform, attnum))
+		if (ATColumnChangeRequiresRewrite(transform, attphysnum))
 			tab->rewrite |= AT_REWRITE_COLUMN_REWRITE;
 	}
 	else if (transform)
@@ -12394,7 +12394,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	HeapTuple	heapTup;
 	Form_pg_attribute attTup,
 				attOldTup;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	HeapTuple	typeTuple;
 	Form_pg_type tform;
 	Oid			targettype;
@@ -12433,8 +12433,8 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
 						colName, RelationGetRelationName(rel))));
 	attTup = (Form_pg_attribute) GETSTRUCT(heapTup);
-	attnum = attTup->attnum;
-	attOldTup = TupleDescAttr(tab->oldDesc, attnum - 1);
+	attphysnum = attTup->attphysnum;
+	attOldTup = TupleDescAttr(tab->oldDesc, attphysnum - 1);
 
 	/* Check for multiple ALTER TYPE on same column --- can't cope */
 	if (attTup->atttypid != attOldTup->atttypid ||
@@ -12465,7 +12465,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	 */
 	if (attTup->atthasdef)
 	{
-		defaultexpr = build_column_default(rel, attnum);
+		defaultexpr = build_column_default(rel, attphysnum);
 		Assert(defaultexpr);
 		defaultexpr = strip_implicit_coercions(defaultexpr);
 		defaultexpr = coerce_to_target_type(NULL,	/* no UNKNOWN params */
@@ -12513,7 +12513,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	ScanKeyInit(&key[2],
 				Anum_pg_depend_refobjsubid,
 				BTEqualStrategyNumber, F_INT4EQ,
-				Int32GetDatum((int32) attnum));
+				Int32GetDatum((int32) attphysnum));
 
 	scan = systable_beginscan(depRel, DependReferenceIndexId, true,
 							  NULL, 3, key);
@@ -12613,7 +12613,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 					ObjectAddress col = GetAttrDefaultColumnAddress(foundObject.objectId);
 
 					if (col.objectId == RelationGetRelid(rel) &&
-						col.objectSubId == attnum)
+						col.objectSubId == attphysnum)
 					{
 						/*
 						 * Ignore the column's own default expression, which
@@ -12719,7 +12719,7 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	ScanKeyInit(&key[2],
 				Anum_pg_depend_objsubid,
 				BTEqualStrategyNumber, F_INT4EQ,
-				Int32GetDatum((int32) attnum));
+				Int32GetDatum((int32) attphysnum));
 
 	scan = systable_beginscan(depRel, DependDependerIndexId, true,
 							  NULL, 3, key);
@@ -12835,16 +12835,16 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	table_close(attrelation, RowExclusiveLock);
 
 	/* Install dependencies on new datatype and collation */
-	add_column_datatype_dependency(RelationGetRelid(rel), attnum, targettype);
-	add_column_collation_dependency(RelationGetRelid(rel), attnum, targetcollid);
+	add_column_datatype_dependency(RelationGetRelid(rel), attphysnum, targettype);
+	add_column_collation_dependency(RelationGetRelid(rel), attphysnum, targetcollid);
 
 	/*
 	 * Drop any pg_statistic entry for the column, since it's now wrong type
 	 */
-	RemoveStatistics(RelationGetRelid(rel), attnum);
+	RemoveStatistics(RelationGetRelid(rel), attphysnum);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
-							  RelationGetRelid(rel), attnum);
+							  RelationGetRelid(rel), attphysnum);
 
 	/*
 	 * Update the default, if present, by brute force --- remove and re-add
@@ -12862,11 +12862,11 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 		 */
 		if (attTup->attgenerated)
 		{
-			Oid			attrdefoid = GetAttrDefaultOid(RelationGetRelid(rel), attnum);
+			Oid			attrdefoid = GetAttrDefaultOid(RelationGetRelid(rel), attphysnum);
 
 			if (!OidIsValid(attrdefoid))
-				elog(ERROR, "could not find attrdef tuple for relation %u attnum %d",
-					 RelationGetRelid(rel), attnum);
+				elog(ERROR, "could not find attrdef tuple for relation %u attphysnum %d",
+					 RelationGetRelid(rel), attphysnum);
 			(void) deleteDependencyRecordsFor(AttrDefaultRelationId, attrdefoid, false);
 		}
 
@@ -12880,14 +12880,14 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 		 * We use RESTRICT here for safety, but at present we do not expect
 		 * anything to depend on the default.
 		 */
-		RemoveAttrDefault(RelationGetRelid(rel), attnum, DROP_RESTRICT, true,
+		RemoveAttrDefault(RelationGetRelid(rel), attphysnum, DROP_RESTRICT, true,
 						  true);
 
-		StoreAttrDefault(rel, attnum, defaultexpr, true, false);
+		StoreAttrDefault(rel, attphysnum, defaultexpr, true, false);
 	}
 
 	ObjectAddressSubSet(address, RelationRelationId,
-						RelationGetRelid(rel), attnum);
+						RelationGetRelid(rel), attphysnum);
 
 	/* Cleanup */
 	heap_freetuple(heapTup);
@@ -13568,7 +13568,7 @@ ATExecAlterColumnGenericOptions(Relation rel,
 	Datum		datum;
 	Form_pg_foreign_table fttableform;
 	Form_pg_attribute atttableform;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	ObjectAddress address;
 
 	if (options == NIL)
@@ -13599,8 +13599,8 @@ ATExecAlterColumnGenericOptions(Relation rel,
 
 	/* Prevent them from altering a system attribute */
 	atttableform = (Form_pg_attribute) GETSTRUCT(tuple);
-	attnum = atttableform->attnum;
-	if (attnum <= 0)
+	attphysnum = atttableform->attphysnum;
+	if (attphysnum <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("cannot alter system column \"%s\"", colName)));
@@ -13641,9 +13641,9 @@ ATExecAlterColumnGenericOptions(Relation rel,
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
-							  atttableform->attnum);
+							  atttableform->attphysnum);
 	ObjectAddressSubSet(address, RelationRelationId,
-						RelationGetRelid(rel), attnum);
+						RelationGetRelid(rel), attphysnum);
 
 	ReleaseSysCache(tuple);
 
@@ -13918,7 +13918,7 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 				Anum_pg_attribute_attrelid,
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relationOid));
-	scan = systable_beginscan(attRelation, AttributeRelidNumIndexId,
+	scan = systable_beginscan(attRelation, AttributeRelidPhysNumIndexId,
 							  true, NULL, 1, key);
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
@@ -15062,7 +15062,7 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 
 				for (int i = 0; i < child_constr->num_defval; i++)
 				{
-					if (child_constr->defval[i].adnum == childatt->attnum)
+					if (child_constr->defval[i].adnum == childatt->attphysnum)
 					{
 						child_expr =
 							TextDatumGetCString(DirectFunctionCall2(pg_get_expr,
@@ -15075,7 +15075,7 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 
 				for (int i = 0; i < parent_constr->num_defval; i++)
 				{
-					if (parent_constr->defval[i].adnum == attribute->attnum)
+					if (parent_constr->defval[i].adnum == attribute->attphysnum)
 					{
 						parent_expr =
 							TextDatumGetCString(DirectFunctionCall2(pg_get_expr,
@@ -15441,7 +15441,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 				Anum_pg_attribute_attrelid,
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(RelationGetRelid(child_rel)));
-	scan = systable_beginscan(catalogRelation, AttributeRelidNumIndexId,
+	scan = systable_beginscan(catalogRelation, AttributeRelidPhysNumIndexId,
 							  true, NULL, 1, key);
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
@@ -16165,7 +16165,7 @@ ATExecSetCompression(AlteredTableInfo *tab,
 	Relation	attrel;
 	HeapTuple	tuple;
 	Form_pg_attribute atttableform;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	char	   *compression;
 	char		cmethod;
 	ObjectAddress address;
@@ -16185,8 +16185,8 @@ ATExecSetCompression(AlteredTableInfo *tab,
 
 	/* prevent them from altering a system attribute */
 	atttableform = (Form_pg_attribute) GETSTRUCT(tuple);
-	attnum = atttableform->attnum;
-	if (attnum <= 0)
+	attphysnum = atttableform->attphysnum;
+	if (attphysnum <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("cannot alter system column \"%s\"", column)));
@@ -16203,13 +16203,13 @@ ATExecSetCompression(AlteredTableInfo *tab,
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
-							  attnum);
+							  attphysnum);
 
 	/*
 	 * Apply the change to indexes as well (only for simple index columns,
 	 * matching behavior of index.c ConstructTupleDescriptor()).
 	 */
-	SetIndexStorageProperties(rel, attrel, attnum,
+	SetIndexStorageProperties(rel, attrel, attphysnum,
 							  false, 0,
 							  true, cmethod,
 							  lockmode);
@@ -16222,7 +16222,7 @@ ATExecSetCompression(AlteredTableInfo *tab,
 	CommandCounterIncrement();
 
 	ObjectAddressSubSet(address, RelationRelationId,
-						RelationGetRelid(rel), attnum);
+						RelationGetRelid(rel), attphysnum);
 	return address;
 }
 
@@ -17247,7 +17247,7 @@ ComputePartitionAttrs(ParseState *pstate, Relation rel, List *partParams, AttrNu
 						 parser_errposition(pstate, pelem->location)));
 			attform = (Form_pg_attribute) GETSTRUCT(atttuple);
 
-			if (attform->attnum <= 0)
+			if (attform->attphysnum <= 0)
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
 						 errmsg("cannot use system column \"%s\" in partition key",
@@ -17266,7 +17266,7 @@ ComputePartitionAttrs(ParseState *pstate, Relation rel, List *partParams, AttrNu
 								   pelem->name),
 						 parser_errposition(pstate, pelem->location)));
 
-			partattrs[attn] = attform->attnum;
+			partattrs[attn] = attform->attphysnum;
 			atttype = attform->atttypid;
 			attcollation = attform->attcollation;
 			ReleaseSysCache(atttuple);
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index 13cb516752..b67128e9fe 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -947,12 +947,12 @@ CreateTriggerFiringOn(CreateTrigStmt *stmt, const char *queryString,
 		foreach(cell, stmt->columns)
 		{
 			char	   *name = strVal(lfirst(cell));
-			int16		attnum;
+			int16		attphysnum;
 			int			j;
 
 			/* Lookup column name.  System columns are not allowed */
-			attnum = attnameAttNum(rel, name, false);
-			if (attnum == InvalidAttrNumber)
+			attphysnum = attnameAttNum(rel, name, false);
+			if (attphysnum == InvalidAttrNumber)
 				ereport(ERROR,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("column \"%s\" of relation \"%s\" does not exist",
@@ -961,14 +961,14 @@ CreateTriggerFiringOn(CreateTrigStmt *stmt, const char *queryString,
 			/* Check for duplicates */
 			for (j = i - 1; j >= 0; j--)
 			{
-				if (columns[j] == attnum)
+				if (columns[j] == attphysnum)
 					ereport(ERROR,
 							(errcode(ERRCODE_DUPLICATE_COLUMN),
 							 errmsg("column \"%s\" specified more than once",
 									name)));
 			}
 
-			columns[i++] = attnum;
+			columns[i++] = attphysnum;
 		}
 	}
 	tgattr = buildint2vector(columns, ncolumns);
diff --git a/src/backend/commands/tsearchcmds.c b/src/backend/commands/tsearchcmds.c
index 4cc4e3c00f..0797ee67f7 100644
--- a/src/backend/commands/tsearchcmds.c
+++ b/src/backend/commands/tsearchcmds.c
@@ -62,10 +62,10 @@ static DefElem *buildDefItem(const char *name, const char *val,
 /*
  * lookup a parser support function and return its OID (as a Datum)
  *
- * attnum is the pg_ts_parser column the function will go into
+ * attphysnum is the pg_ts_parser column the function will go into
  */
 static Datum
-get_ts_parser_func(DefElem *defel, int attnum)
+get_ts_parser_func(DefElem *defel, int attphysnum)
 {
 	List	   *funcName = defGetQualifiedName(defel);
 	Oid			typeId[3];
@@ -75,7 +75,7 @@ get_ts_parser_func(DefElem *defel, int attnum)
 
 	retTypeId = INTERNALOID;	/* correct for most */
 	typeId[0] = INTERNALOID;
-	switch (attnum)
+	switch (attphysnum)
 	{
 		case Anum_pg_ts_parser_prsstart:
 			nargs = 2;
@@ -107,7 +107,7 @@ get_ts_parser_func(DefElem *defel, int attnum)
 		default:
 			/* should not be here */
 			elog(ERROR, "unrecognized attribute for text search parser: %d",
-				 attnum);
+				 attphysnum);
 			nargs = 0;			/* keep compiler quiet */
 	}
 
@@ -597,10 +597,10 @@ AlterTSDictionary(AlterTSDictionaryStmt *stmt)
 /*
  * lookup a template support function and return its OID (as a Datum)
  *
- * attnum is the pg_ts_template column the function will go into
+ * attphysnum is the pg_ts_template column the function will go into
  */
 static Datum
-get_ts_template_func(DefElem *defel, int attnum)
+get_ts_template_func(DefElem *defel, int attphysnum)
 {
 	List	   *funcName = defGetQualifiedName(defel);
 	Oid			typeId[4];
@@ -613,7 +613,7 @@ get_ts_template_func(DefElem *defel, int attnum)
 	typeId[1] = INTERNALOID;
 	typeId[2] = INTERNALOID;
 	typeId[3] = INTERNALOID;
-	switch (attnum)
+	switch (attphysnum)
 	{
 		case Anum_pg_ts_template_tmplinit:
 			nargs = 1;
@@ -624,7 +624,7 @@ get_ts_template_func(DefElem *defel, int attnum)
 		default:
 			/* should not be here */
 			elog(ERROR, "unrecognized attribute for text search template: %d",
-				 attnum);
+				 attphysnum);
 			nargs = 0;			/* keep compiler quiet */
 	}
 
diff --git a/src/backend/commands/typecmds.c b/src/backend/commands/typecmds.c
index 9b92b04242..e59afbe7cd 100644
--- a/src/backend/commands/typecmds.c
+++ b/src/backend/commands/typecmds.c
@@ -2758,10 +2758,10 @@ AlterDomainNotNull(List *names, bool notNull)
 				/* Test attributes that are of the domain */
 				for (i = 0; i < rtc->natts; i++)
 				{
-					int			attnum = rtc->atts[i];
-					Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+					int			attphysnum = rtc->atts[i];
+					Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
-					if (slot_attisnull(slot, attnum))
+					if (slot_attisnull(slot, attphysnum))
 					{
 						/*
 						 * In principle the auxiliary information for this
@@ -2776,7 +2776,7 @@ AlterDomainNotNull(List *names, bool notNull)
 								 errmsg("column \"%s\" of table \"%s\" contains null values",
 										NameStr(attr->attname),
 										RelationGetRelationName(testrel)),
-								 errtablecol(testrel, attnum)));
+								 errtablecol(testrel, attphysnum)));
 					}
 				}
 			}
@@ -3174,13 +3174,13 @@ validateDomainConstraint(Oid domainoid, char *ccbin)
 			/* Test attributes that are of the domain */
 			for (i = 0; i < rtc->natts; i++)
 			{
-				int			attnum = rtc->atts[i];
+				int			attphysnum = rtc->atts[i];
 				Datum		d;
 				bool		isNull;
 				Datum		conResult;
-				Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+				Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
-				d = slot_getattr(slot, attnum, &isNull);
+				d = slot_getattr(slot, attphysnum, &isNull);
 
 				econtext->domainValue_datum = d;
 				econtext->domainValue_isNull = isNull;
@@ -3204,7 +3204,7 @@ validateDomainConstraint(Oid domainoid, char *ccbin)
 							 errmsg("column \"%s\" of table \"%s\" contains values that violate the new constraint",
 									NameStr(attr->attname),
 									RelationGetRelationName(testrel)),
-							 errtablecol(testrel, attnum)));
+							 errtablecol(testrel, attphysnum)));
 				}
 			}
 
diff --git a/src/backend/executor/execExpr.c b/src/backend/executor/execExpr.c
index 2831e7978b..63e0617430 100644
--- a/src/backend/executor/execExpr.c
+++ b/src/backend/executor/execExpr.c
@@ -379,7 +379,7 @@ ExecBuildProjectionInfo(List *targetList,
 	{
 		TargetEntry *tle = lfirst_node(TargetEntry, lc);
 		Var		   *variable = NULL;
-		AttrNumber	attnum = 0;
+		AttrNumber	attphysnum = 0;
 		bool		isSafeVar = false;
 
 		/*
@@ -396,13 +396,13 @@ ExecBuildProjectionInfo(List *targetList,
 		{
 			/* Non-system Var, but how safe is it? */
 			variable = (Var *) tle->expr;
-			attnum = variable->varattno;
+			attphysnum = variable->varattno;
 
 			if (inputDesc == NULL)
 				isSafeVar = true;	/* can't check, just assume OK */
-			else if (attnum <= inputDesc->natts)
+			else if (attphysnum <= inputDesc->natts)
 			{
-				Form_pg_attribute attr = TupleDescAttr(inputDesc, attnum - 1);
+				Form_pg_attribute attr = TupleDescAttr(inputDesc, attphysnum - 1);
 
 				/*
 				 * If user attribute is dropped or has a type mismatch, don't
@@ -439,7 +439,7 @@ ExecBuildProjectionInfo(List *targetList,
 					break;
 			}
 
-			scratch.d.assign_var.attnum = attnum - 1;
+			scratch.d.assign_var.attphysnum = attphysnum - 1;
 			scratch.d.assign_var.resultnum = tle->resno - 1;
 			ExprEvalPushStep(state, &scratch);
 		}
@@ -584,15 +584,15 @@ ExecBuildUpdateProjection(List *targetList,
 	 * sufficiently deconstructed.  The scan tuple must be deconstructed at
 	 * least as far as the last old column we need.
 	 */
-	for (int attnum = relDesc->natts; attnum > 0; attnum--)
+	for (int attphysnum = relDesc->natts; attphysnum > 0; attphysnum--)
 	{
-		Form_pg_attribute attr = TupleDescAttr(relDesc, attnum - 1);
+		Form_pg_attribute attr = TupleDescAttr(relDesc, attphysnum - 1);
 
 		if (attr->attisdropped)
 			continue;
-		if (bms_is_member(attnum, assignedCols))
+		if (bms_is_member(attphysnum, assignedCols))
 			continue;
-		deform.last_scan = attnum;
+		deform.last_scan = attphysnum;
 		break;
 	}
 
@@ -668,7 +668,7 @@ ExecBuildUpdateProjection(List *targetList,
 		{
 			/* Just assign from the outer tuple. */
 			scratch.opcode = EEOP_ASSIGN_OUTER_VAR;
-			scratch.d.assign_var.attnum = outerattnum;
+			scratch.d.assign_var.attphysnum = outerattnum;
 			scratch.d.assign_var.resultnum = targetattnum - 1;
 			ExprEvalPushStep(state, &scratch);
 		}
@@ -695,9 +695,9 @@ ExecBuildUpdateProjection(List *targetList,
 	 * Now generate code to copy over any old columns that were not assigned
 	 * to, and to ensure that dropped columns are set to NULL.
 	 */
-	for (int attnum = 1; attnum <= relDesc->natts; attnum++)
+	for (int attphysnum = 1; attphysnum <= relDesc->natts; attphysnum++)
 	{
-		Form_pg_attribute attr = TupleDescAttr(relDesc, attnum - 1);
+		Form_pg_attribute attr = TupleDescAttr(relDesc, attphysnum - 1);
 
 		if (attr->attisdropped)
 		{
@@ -710,15 +710,15 @@ ExecBuildUpdateProjection(List *targetList,
 			ExprEvalPushStep(state, &scratch);
 			/* ... then assign it to the result slot */
 			scratch.opcode = EEOP_ASSIGN_TMP;
-			scratch.d.assign_tmp.resultnum = attnum - 1;
+			scratch.d.assign_tmp.resultnum = attphysnum - 1;
 			ExprEvalPushStep(state, &scratch);
 		}
-		else if (!bms_is_member(attnum, assignedCols))
+		else if (!bms_is_member(attphysnum, assignedCols))
 		{
 			/* Certainly the right type, so needn't check */
 			scratch.opcode = EEOP_ASSIGN_SCAN_VAR;
-			scratch.d.assign_var.attnum = attnum - 1;
-			scratch.d.assign_var.resultnum = attnum - 1;
+			scratch.d.assign_var.attphysnum = attphysnum - 1;
+			scratch.d.assign_var.resultnum = attphysnum - 1;
 			ExprEvalPushStep(state, &scratch);
 		}
 	}
@@ -925,7 +925,7 @@ ExecInitExprRec(Expr *node, ExprState *state,
 				else if (variable->varattno <= 0)
 				{
 					/* system column */
-					scratch.d.var.attnum = variable->varattno;
+					scratch.d.var.attphysnum = variable->varattno;
 					scratch.d.var.vartype = variable->vartype;
 					switch (variable->varno)
 					{
@@ -946,7 +946,7 @@ ExecInitExprRec(Expr *node, ExprState *state,
 				else
 				{
 					/* regular user column */
-					scratch.d.var.attnum = variable->varattno - 1;
+					scratch.d.var.attphysnum = variable->varattno - 1;
 					scratch.d.var.vartype = variable->vartype;
 					switch (variable->varno)
 					{
@@ -2890,22 +2890,22 @@ get_last_attnums_walker(Node *node, LastAttnumInfo *info)
 	if (IsA(node, Var))
 	{
 		Var		   *variable = (Var *) node;
-		AttrNumber	attnum = variable->varattno;
+		AttrNumber	attphysnum = variable->varattno;
 
 		switch (variable->varno)
 		{
 			case INNER_VAR:
-				info->last_inner = Max(info->last_inner, attnum);
+				info->last_inner = Max(info->last_inner, attphysnum);
 				break;
 
 			case OUTER_VAR:
-				info->last_outer = Max(info->last_outer, attnum);
+				info->last_outer = Max(info->last_outer, attphysnum);
 				break;
 
 				/* INDEX_VAR is handled by default case */
 
 			default:
-				info->last_scan = Max(info->last_scan, attnum);
+				info->last_scan = Max(info->last_scan, attphysnum);
 				break;
 		}
 		return false;
@@ -4040,7 +4040,7 @@ ExecBuildGroupingEqual(TupleDesc ldesc, TupleDesc rdesc,
 
 		/* left arg */
 		scratch.opcode = EEOP_INNER_VAR;
-		scratch.d.var.attnum = attno - 1;
+		scratch.d.var.attphysnum = attno - 1;
 		scratch.d.var.vartype = latt->atttypid;
 		scratch.resvalue = &fcinfo->args[0].value;
 		scratch.resnull = &fcinfo->args[0].isnull;
@@ -4048,7 +4048,7 @@ ExecBuildGroupingEqual(TupleDesc ldesc, TupleDesc rdesc,
 
 		/* right arg */
 		scratch.opcode = EEOP_OUTER_VAR;
-		scratch.d.var.attnum = attno - 1;
+		scratch.d.var.attphysnum = attno - 1;
 		scratch.d.var.vartype = ratt->atttypid;
 		scratch.resvalue = &fcinfo->args[1].value;
 		scratch.resnull = &fcinfo->args[1].isnull;
@@ -4174,7 +4174,7 @@ ExecBuildParamSetEqual(TupleDesc desc,
 
 		/* left arg */
 		scratch.opcode = EEOP_INNER_VAR;
-		scratch.d.var.attnum = attno;
+		scratch.d.var.attphysnum = attno;
 		scratch.d.var.vartype = att->atttypid;
 		scratch.resvalue = &fcinfo->args[0].value;
 		scratch.resnull = &fcinfo->args[0].isnull;
@@ -4182,7 +4182,7 @@ ExecBuildParamSetEqual(TupleDesc desc,
 
 		/* right arg */
 		scratch.opcode = EEOP_OUTER_VAR;
-		scratch.d.var.attnum = attno;
+		scratch.d.var.attphysnum = attno;
 		scratch.d.var.vartype = att->atttypid;
 		scratch.resvalue = &fcinfo->args[1].value;
 		scratch.resnull = &fcinfo->args[1].isnull;
